(function () {
  if (typeof window.jsb === 'object') {
    if (window.JavascriptJavaBridge) {
      jsb.reflection = new JavascriptJavaBridge();
    } else if (window.JavaScriptObjCBridge) {
      jsb.reflection = new JavaScriptObjCBridge();
    }
    //根据环境区分热更新路径key
    let env = jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "getEnv"
      , "()I");
    let key = 'HotUpdateSearchPaths-online';
    if (env == 1) {
        key = 'HotUpdateSearchPaths-qa'
    }
    
    // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
    //   , "(Ljava/lang/String;)V", "key:" + key);
    var hotUpdateSearchPaths = localStorage.getItem(key);

    // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
    // , "(Ljava/lang/String;)V", "hotUpdateSearchPaths:"+hotUpdateSearchPaths);
    if (hotUpdateSearchPaths) {
        //清除热更新缓存 start
        var paths = JSON.parse(hotUpdateSearchPaths);
        jsb.fileUtils.setSearchPaths(paths);

        var fileList = [];
        var storagePath = paths[0] || '';
        // jsb.fileUtils.listFilesRecursively("/data/user/0/com.meelive.ingkee/files/", fileList);
        // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
        //   , "(Ljava/lang/String;)V", "fileList file length:" + fileList.length);
        
          // jsb.fileUtils.listFilesRecursively('@assets/themeroom_assets/', fileList);
          // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
          //   , "(Ljava/lang/String;)V", "fileList assets length:" + fileList.length);
      
          
        if(storagePath.substring(storagePath.length - 1, storagePath.length) == '/') {
          storagePath = storagePath.substring(0, storagePath.length - 1)
        }
        var tempPath = storagePath + '_temp/';
        var baseOffset = tempPath.length;

        // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
        //   , "(Ljava/lang/String;)V", "tempPath:" + tempPath);
      
      if (jsb.fileUtils.isDirectoryExist(tempPath) && !jsb.fileUtils.isFileExist(tempPath + 'project.manifest.temp')) {
            jsb.fileUtils.listFilesRecursively(tempPath, fileList);
            fileList.forEach(srcPath => {
                var relativePath = srcPath.substr(baseOffset);
                var dstPath = storagePath + relativePath;

                if (srcPath[srcPath.length] == '/') {
                    cc.fileUtils.createDirectory(dstPath)
                } else {
                    if (cc.fileUtils.isFileExist(dstPath)) {
                        cc.fileUtils.removeFile(dstPath)
                    }
                    cc.fileUtils.renameFile(srcPath, dstPath);
                }
            })
            cc.fileUtils.removeDirectory(tempPath);

            // localStorage.setItem()
        }
        //清除热更新缓存 end

      
        var compareVersion = function(curVersion, targetVersion) {
          let vA = curVersion.split('.');
          let vB = targetVersion.split('.');
          for (let i = 0; i < vA.length; ++i) {
              let a = parseInt(vA[i]);
              let b = parseInt(vB[i] || "0");
              if (a === b) {
                  continue;
              }
              else {
                  return a - b;
              }
          }
          if (vB.length > vA.length) {
              return -1;
          }
          else {
              return 0;
          }
        }
      
        // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
        //   , "(Ljava/lang/String;)V", "paths. ini ini in in :");
        var paths = jsb.fileUtils.getSearchPaths();
      
        if (paths.length == 1) { //没有热更新过
            return;
        }
        // var packagedSearchPath = "@assets/";
      var packagedSearchPath = "@assets/themeroom_assets/";
      var packagedPath;
        // console.log("searchPaths:", paths);
        var maxVersion = "0.0.0";
        var packagedVersion = ""//打包时的版本号
      
      for (var i = 0, length = paths.length; i < length; i++) {
            let path = paths[i];
            // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
            //   , "(Ljava/lang/String;)V", "path:"+path);
            var manifestUrl = path + "project.manifest";
            var isExist = jsb.fileUtils.isFileExist(manifestUrl);
            // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
            //   , "(Ljava/lang/String;)V", "manifestUrl:" + manifestUrl + ",, isExist:" + isExist);
        
        
            if (path.indexOf(packagedSearchPath) != -1) {
              // var packagedSearchFiles = [];
              //包内地址文件js获取不到，调用native方法获取
              manifestUrl = jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "getNativeManifestPath"
                , "(Ljava/lang/String;)Ljava/lang/String;", path);
              isExist = jsb.fileUtils.isFileExist(manifestUrl);
              // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
              //     , "(Ljava/lang/String;)V", "isFileExist:" + isExist);
            }
            if (!isExist) {
                continue;
            }
            var version = JSON.parse(jsb.fileUtils.getStringFromFile(manifestUrl)).version;
        

        // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
        // , "(Ljava/lang/String;)V", "version:"+version);

            var compResult = compareVersion(maxVersion, version);
            if (compResult < 0) {
                maxVersion = version;
            }
            if (path.indexOf(packagedSearchPath) != -1) {
              packagedVersion = version;
              packagedPath = path
          }
      }

        //安装过包，并且是内包版本大于热更新目录，移除其他的目录
        if (maxVersion == packagedVersion) {
          // jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
          // , "(Ljava/lang/String;)V","CheckSearchPath ReInstall Package...");
            for(var i = 0, length = paths.length; i < length; i++) {
                var path = paths[i];
                if (path.indexOf(packagedSearchPath) == -1) {
                    jsb.fileUtils.removeDirectory(path);
        //             jsb.reflection.callStaticMethod("com/meelive/ingkee/business/room/vocal/IKThemeRoomBridgeService", "log"
        // , "(Ljava/lang/String;)V", "remove removeDirectory:"+ path);
                }
            }
            localStorage.setItem(key, JSON.stringify([packagedPath]));
            jsb.fileUtils.setSearchPaths([packagedPath]);
        }
      
      // jsb.fileUtils.setSearchPaths(JSON.parse(hotUpdateSearchPaths));
    }
  }
})();

window.boot = function () {
    var settings = window._CCSettings;
    window._CCSettings = undefined;
    var onProgress = null;
    
    var RESOURCES = cc.AssetManager.BuiltinBundleName.RESOURCES;
    var INTERNAL = cc.AssetManager.BuiltinBundleName.INTERNAL;
    var MAIN = cc.AssetManager.BuiltinBundleName.MAIN;
    function setLoadingDisplay () {
        // Loading splash scene
        var splash = document.getElementById('splash');
        var progressBar = splash.querySelector('.progress-bar span');
        onProgress = function (finish, total) {
            var percent = 100 * finish / total;
            if (progressBar) {
                progressBar.style.width = percent.toFixed(2) + '%';
            }
        };
        splash.style.display = 'block';
        progressBar.style.width = '0%';

        cc.director.once(cc.Director.EVENT_AFTER_SCENE_LAUNCH, function () {
            splash.style.display = 'none';
        });
    }

    var onStart = function () {

        cc.view.enableRetina(true);
        cc.view.resizeWithBrowserSize(true);

        if (cc.sys.isBrowser) {
            setLoadingDisplay();
        }

        if (cc.sys.isMobile) {
            if (settings.orientation === 'landscape') {
                cc.view.setOrientation(cc.macro.ORIENTATION_LANDSCAPE);
            }
            else if (settings.orientation === 'portrait') {
                cc.view.setOrientation(cc.macro.ORIENTATION_PORTRAIT);
            }
            cc.view.enableAutoFullScreen([
                cc.sys.BROWSER_TYPE_BAIDU,
                cc.sys.BROWSER_TYPE_BAIDU_APP,
                cc.sys.BROWSER_TYPE_WECHAT,
                cc.sys.BROWSER_TYPE_MOBILE_QQ,
                cc.sys.BROWSER_TYPE_MIUI,
                cc.sys.BROWSER_TYPE_HUAWEI,
                cc.sys.BROWSER_TYPE_UC,
            ].indexOf(cc.sys.browserType) < 0);
        }

        // Limit downloading max concurrent task to 2,
        // more tasks simultaneously may cause performance draw back on some android system / browsers.
        // You can adjust the number based on your own test result, you have to set it before any loading process to take effect.
        if (cc.sys.isBrowser && cc.sys.os === cc.sys.OS_ANDROID) {
            cc.assetManager.downloader.maxConcurrency = 2;
            cc.assetManager.downloader.maxRequestsPerFrame = 2;
        }

        var launchScene = settings.launchScene;
        var bundle = cc.assetManager.bundles.find(function (b) {
            return b.getSceneInfo(launchScene);
        });
        
        bundle.loadScene(launchScene, null, onProgress,
            function (err, scene) {
                if (!err) {
                    cc.director.runSceneImmediate(scene);
                    if (cc.sys.isBrowser) {
                        // show canvas
                        var canvas = document.getElementById('GameCanvas');
                        canvas.style.visibility = '';
                        var div = document.getElementById('GameDiv');
                        if (div) {
                            div.style.backgroundImage = '';
                        }
                        console.log('Success to load scene: ' + launchScene);
                    }
                }
            }
        );

    };

    var option = {
        id: 'GameCanvas',
        debugMode: settings.debug ? cc.debug.DebugMode.INFO : cc.debug.DebugMode.ERROR,
        showFPS: false,
        frameRate: 30,
        groupList: settings.groupList,
        collisionMatrix: settings.collisionMatrix,
    };

    cc.assetManager.init({ 
        bundleVers: settings.bundleVers,
        remoteBundles: settings.remoteBundles,
        server: settings.server
    });
    
    var bundleRoot = [INTERNAL];
    settings.hasResourcesBundle && bundleRoot.push(RESOURCES);

    var count = 0;
    function cb (err) {
        if (err) return console.error(err.message, err.stack);
        count++;
        if (count === bundleRoot.length + 1) {
            cc.assetManager.loadBundle(MAIN, function (err) {
                if (!err) cc.game.run(option, onStart);
            });
        }
    }

    cc.assetManager.loadScript(settings.jsList.map(function (x) { return 'src/' + x;}), cb);

    for (var i = 0; i < bundleRoot.length; i++) {
        cc.assetManager.loadBundle(bundleRoot[i], cb);
    }
};

if (window.jsb) {
    var isRuntime = (typeof loadRuntime === 'function');
    if (isRuntime) {
        require('src/settings.js');
        require('src/cocos2d-runtime.js');
        if (CC_PHYSICS_BUILTIN || CC_PHYSICS_CANNON) {
            require('src/physics.js');
        }
        require('jsb-adapter/engine/index.js');
    }
    else {
        require('src/settings.js');
        require('src/cocos2d-jsb.js');
        if (CC_PHYSICS_BUILTIN || CC_PHYSICS_CANNON) {
            require('src/physics.js');
        }
        require('jsb-adapter/jsb-engine.js');
    }

    cc.macro.CLEANUP_IMAGE_CACHE = true;
    window.boot();
}
